@if (@CodeSection == @Batch) @then
@echo off
pushd "%~dp0"

if [%1]==[] goto usage

set QtPathFormat=CScript //nologo //E:JScript "%~F0" QtPathFormat
set ReplaceRegexInFile=CScript //nologo //E:JScript "%~F0" ReplaceRegexInFile

:: Находим последнюю версию программы в папке apps
for /D %%D in (apps\*) do set appsfolder=%%D

if [%2]==[] goto run
if %2==--silent goto run
if %2==--edit goto edit

:: Сообщение при запуске без аргументов
:usage
echo Usage:
echo     %0 ^<ProjectFile.xml^>
echo     %0 ^<ProjectFile.xml^> --silent
echo     %0 ^<ProjectFile.xml^> --edit
goto :eof

:edit
echo Edit script "%~n1"

for /f "tokens=*" %%a in ('%QtPathFormat% %1') DO (set filename=%%a)
:: Меняем в настройках имя текущего проекта
%ReplaceRegexInFile% "%appsfolder%\settings.ini" "^CurrentFileName=.*?$" "CurrentFileName=%filename%"
start "" "BrowserAutomationStudio.exe"
echo Done.

goto :eof

:run
echo Run script "%~n1"

:: Копируем запускаемый проект в файл, который запускается по-умолчанию
copy /y "%1" "%appsfolder%\project.xml"
:: Если имя скрипта в проекте пустое заменяем его на имя файла
%ReplaceRegexInFile% "%appsfolder%\project.xml" "<ScriptName><\/ScriptName>" "<ScriptName>%~n1</ScriptName>"
:: Запускаем BAS
start "" /D "%appsfolder%" "FastExecuteScript.exe" %2
echo Done.
goto :eof

@end

// JScript функции
if(WScript.Arguments(0) == "QtPathFormat")
{
  QtPathFormat(WScript.Arguments(1));
}
else if(WScript.Arguments(0) == "ReplaceRegexInFile")
{
  ReplaceRegexInFile(WScript.Arguments(1), WScript.Arguments(2), WScript.Arguments(3));
}

function QtPathFormat(string)
{
  WScript.Echo(escape(string.replace(/\\/g, "/")).replace(/%[u]?/g, "\\x"));
}

function ReplaceRegexInFile(filename, find, replace)
{
  var regex = new RegExp(find, 'm');
  var Reading = 1;
  var Writing = 2;
  var FSO = WScript.CreateObject("Scripting.FileSystemObject");
  var oFile = FSO.OpenTextFile(filename, Reading);
  var text = oFile.ReadAll();
  oFile.Close();
  var newText = text.replace(regex, replace);
  var oFile = FSO.OpenTextFile(filename, Writing);
  oFile.Write(newText);
  oFile.Close();
}